// Code to compute the median of a list of numbers using an ArrayList
// with the Collections.sort(..) routine. Reads a file from the
// command line with format like the following:
// 
// Dexter     35
// Debra      32
// Angelos    43
// ...

import java.util.*;
import java.io.File;
public class ComputeMedian{
  public static void main(String args[]) throws Exception{
    String fname = args[0];
    Scanner in = new Scanner(new File(fname));
    ArrayList<Integer> ages = new ArrayList<Integer>();
    while(in.hasNext()){
      in.next();
      int age = in.nextInt();
      ages.add(age);
    }
    in.close();
    Collections.sort(ages);
    System.out.println("Sorted ages:");
    for(int i=0; i<ages.size(); i++){
      System.out.printf("%2d: %d\n",i, ages.get(i));
    }

    int index = ages.size() / 2;
    int median = ages.get(index);
    System.out.printf("median: %d\n",median);
  }
}
